package eu.mhsl.minecraft.WorldMuseum.items;

import eu.mhsl.minecraft.WorldMuseum.Main;
import eu.mhsl.minecraft.WorldMuseum.items.actionItems.*;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;

import java.util.ArrayList;
import java.util.List;

public class ActionItemManager {
    private static ActionItemManager instance;
    private final List<IActionItem> actionObjects = new ArrayList<>();

    private ActionItemManager() {
        List<IActionItem> actionItems = List.of(
            new WorldSelector(),
            new LeaveItem(),
            new SpawnTeleport(),
            new SpeedChanger()
        );

        actionItems.forEach(actionItem -> Bukkit.getPluginManager().registerEvents(actionItem, Main.instance()));
        actionObjects.addAll(actionItems);    }

    public static ActionItemManager getInstance() {
        if (instance == null) instance = new ActionItemManager();
        return instance;
    }

    public void givePlayerItems(Player p) {
        actionObjects.forEach(actionObject -> p.getInventory().setItem(actionObject.getItemLocation(), actionObject.getItem()));
    }

    public List<IActionItem> getActionItems() {
        return actionObjects;
    }
}
