package eu.mhsl.minecraft.WorldMuseum.items.actionItems;

import eu.mhsl.minecraft.WorldMuseum.Main;
import eu.mhsl.minecraft.WorldMuseum.util.BungeeCord;
import net.kyori.adventure.text.Component;
import org.bukkit.Material;
import org.bukkit.configuration.ConfigurationSection;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import org.jetbrains.annotations.NotNull;

import java.util.Objects;

public class LeaveItem implements IActionItem {
    private final ItemStack item = generateItem();

    private ItemStack generateItem() {
        ItemStack item = new ItemStack(Material.RED_BED);
        ItemMeta meta = item.getItemMeta();
        meta.displayName(Component.text("Leave World Museum"));
        item.setItemMeta(meta);
        return item;
    }

    @Override
    public void action(@NotNull Player player) {
        ConfigurationSection bungeeSettings = Main.instance().getConfig().getConfigurationSection("bungee");
        Objects.requireNonNull(bungeeSettings);

        if(!(bungeeSettings.getBoolean("enabled", false))) {
            player.sendMessage(Component.text("Bungeecord is not enabled. You can't be transferred."));
            return;
        }
        if(!bungeeSettings.getBoolean("returnOnSelectExit")) return;
        sendPlayerToExit(player);
    }

    private void sendPlayerToExit(Player player) {
        BungeeCord.connect(player, Main.instance().getConfig().getString("bungee.returnToServer"));
    }

    @Override
    public ItemStack getItem() {
        return item;
    }

    @Override
    public int getItemLocation() {
        return 8;
    }
}
