package eu.mhsl.minecraft.WorldMuseum.items.actionItems;

import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import org.jetbrains.annotations.NotNull;

import java.util.List;
import java.util.stream.IntStream;

public class SpeedChanger implements IActionItem {
    List<Float> flySpeeds = List.of(0.1f, 0.3f, 0.5f, 0.7f);

    @Override
    public void action(@NotNull Player player) {
        IntStream.range(0, flySpeeds.size())
            .filter(i -> flySpeeds.get(i).equals(player.getFlySpeed()))
            .findFirst()
            .ifPresentOrElse(
                newFlyMode -> setFlySpeed(player, (newFlyMode + 1) % flySpeeds.size()),
                () -> setFlySpeed(player, 0)
            );

    }

    public void setFlySpeed(Player player, int mode) {
        player.setFlySpeed(flySpeeds.get(mode));
        player.sendActionBar(Component.text(String.format("Fluggeschwindigkeit: %s", mode), NamedTextColor.GOLD));
    }

    @Override
    public ItemStack getItem() {
        ItemStack item = new ItemStack(Material.FEATHER);
        ItemMeta meta = item.getItemMeta();
        meta.displayName(Component.text("Fluggeschwindigkeit"));
        item.setItemMeta(meta);
        return item;
    }

    @Override
    public int getItemLocation() {
        return 1;
    }
}
