package eu.mhsl.minecraft.WorldMuseum.viewableWorld;

import com.destroystokyo.paper.event.player.PlayerTeleportEndGatewayEvent;
import io.papermc.paper.event.entity.EntityMoveEvent;
import io.papermc.paper.event.player.PlayerOpenSignEvent;
import org.bukkit.Material;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockFromToEvent;
import org.bukkit.event.block.BlockGrowEvent;
import org.bukkit.event.block.BlockRedstoneEvent;
import org.bukkit.event.entity.*;
import org.bukkit.event.player.PlayerBedEnterEvent;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.event.player.PlayerPortalEvent;
import org.bukkit.event.player.PlayerUnleashEntityEvent;
import org.bukkit.event.world.ChunkUnloadEvent;

import java.util.List;

public class ViewableWorldListener implements Listener {
    @EventHandler
    public void disableRedstone(BlockRedstoneEvent event) {
        event.setNewCurrent(0);
    }
    @EventHandler
    public void disableEntitySpawn(EntitySpawnEvent event) {
        event.setCancelled(true);
    }
    @EventHandler
    public void preventEntityMove(EntityMoveEvent event) {
        event.setCancelled(true);
    }
    @EventHandler
    public void preventBlockFromTo(BlockFromToEvent event) {
        event.setCancelled(true);
    }
    @EventHandler
    public void preventGrowth(BlockGrowEvent event) {
        event.setCancelled(true);
    }
    @EventHandler
    public void onChunkUnload(ChunkUnloadEvent event) {
        event.setSaveChunk(false);
    }
    @EventHandler
    public void onEntityDamage(EntityDamageEvent event) {
        event.setCancelled(true);
    }
    @EventHandler
    public void preventPortal(PlayerPortalEvent event) {
        event.setCancelled(true);
    }
    @EventHandler
    public void preventEntityPortal(EntityPortalEvent event) {
        event.setCancelled(true);
    }
    @EventHandler
    public void noSleep(PlayerBedEnterEvent event) {
        event.setCancelled(true);
    }
    @EventHandler
    public void noHunger(FoodLevelChangeEvent event) {
        event.setCancelled(true);
    }
    @EventHandler
    public void noItemPickup(EntityPickupItemEvent event) {
        event.setCancelled(true);
    }
    @EventHandler
    public void noTnt(ExplosionPrimeEvent event) {
        event.setCancelled(true);
    }
    @EventHandler
    public void noCreeper(EntityExplodeEvent event) {
        event.setCancelled(true);
    }
    @EventHandler
    public void noSignEdit(PlayerOpenSignEvent event) {
        event.setCancelled(true);
    }
    @EventHandler
    public void noUnleash(PlayerUnleashEntityEvent event) {
        event.setCancelled(true);
    }
    @EventHandler
    public void noEndGateway(PlayerTeleportEndGatewayEvent event) {
        event.setCancelled(true);
    }
    @EventHandler
    public void noInteract(PlayerInteractEvent event) {
        if(event.getClickedBlock() == null) return;
        if(!List.of(Material.CHEST, Material.SHULKER_BOX).contains(event.getClickedBlock().getType())) return;
        event.setCancelled(true);
    }
}
